/********************************************************************\

  Name:         ces2117.h
  Created by:   Stefan Ritt

  Cotents:      CAMAC functions for CES VCC 2117 controller

  Revision history
  ------------------------------------------------------------------
  date        by    modification
  ---------   ---   ------------------------------------------------
  03-MAR-98   SR    created

\********************************************************************/

/*------------------------------------------------------------------*/

/*
   macro                purpose

   CAMO                 24 bit output
   CAMI                 24 bit input
   CAMS                 return X,Q


   CAMAC_SET_INHIBIT
   CAMAC_CLEAR_INHIBIT
   CAMAC_C_CYCLE
   CAMAC_Z_CYCLE
   CAMAC_LAM_ENABLE
   CAMAC_LAM_DISABLE
   CAMAC_SET_LAM_BIT(station)             set mask bit for station
   CAMAC_CLEAR_LAM_BIT(station)           clear mask bit for station
   CAMAC_READ_LAM()                       read encoded lam

*/

/*------------------------------------------------------------------*/

#define CAMO(n,a,f,d) *((unsigned long *) (0xC00000 | ((((f<<5)|n)<<4)|a)<<2)) = (d)
#define CAMI(n,a,f,d) *(d) = *((unsigned long *) (0xC00000 | ((((f<<5)|n)<<4)|a)<<2)) & 0xFFFFFF
#define CAMIQ(n,a,f,d,x,q) { *(d) = *((unsigned long *) (0xC00000 | ((((f<<5)|n)<<4)|a)<<2)); \
                             *x = (*(d) & 0x40000000) > 0; \
                             *q = (*(d) & 0x80000000) > 0; \
                             *(d) &= 0xFFFFFF; }

#define CAMAC_SET_INHIBIT()     *((unsigned long *) 0xC0C7A4) = 0
#define CAMAC_CLEAR_INHIBIT()   *((unsigned long *) 0xC0E7A4) = 0
#define CAMAC_C_CYCLE()         *((unsigned long *) 0xC0D724) = 0
#define CAMAC_Z_CYCLE()         *((unsigned long *) 0xC0D720) = 0

