/*-----------------------------------------------------------------------------
 * Copyright (c) 1996      TRIUMF Data Acquistion Group
 * Please leave this header in any reproduction of that distribution
 * 
 * TRIUMF Data Acquisition Group, 4004 Wesbrook Mall, Vancouver, B.C. V6T 2A3
 * Email: online@triumf.ca           Tel: (604) 222-1047  Fax: (604) 222-1074
 *         amaudruz@triumf.ca
 * ----------------------------------------------------------------------------
 *  
 * Description	:
 *
 * Author:  Pierre-Andre Amaudruz Data Acquisition Group
 * 
 * Revision 1.0  1996/ Pierre	 Initial revision
 * ---------------------------------------------------------------------------- */
/*------------------------------------------------------------------------------------*/
typedef unsigned long  DWORD;
typedef unsigned short WORD;

#include "libvme.h"
#define PCOS_12     0x7f0000   /* VME 32k mode  Base address buffer */ 

void vio(void)
{
  printf("---> VME Macros (libvme.h) <---\n");
  printf("ena1190  0x7f0000         <--- enable  VME buffer\n");
  printf("dis1190  0x7f0000         <--- disable VME buffer\n");
  printf("res1190  0x7f0000         <--- reset   VME buffer\n");
  printf("cn1190   0x7f0000         <--- read    word count register\n");
  printf("rd1190   0x7f0000         <--- read             VME buffer\n");
  printf("rd1190l  0x7f0000         <--- read low  word   VME buffer\n");
  printf("rd1190h  0x7f0000         <--- read high word   VME buffer\n");
  printf("clr1151  0x7a00           <--- clear   VME scaler\n");
  printf("rd1151   0x7a00           <--- read    VME scaler\n");
}
void cn1190 ( DWORD vmeBase)
{
  WORD count;
VME_COUNT_1190(vmeBase, &count);
printf(" counter %i\n",count);
}

void rd1190l ( DWORD vmeBase , DWORD r)
{
  DWORD i, dd[1024], *pdd;
  WORD buf_counter;
  for (i=0;i<1024;i++)
    dd[i] = 0;
  pdd = &dd[0];
  VME_DISABLE_1190(vmeBase);
  VME_COUNT_1190(vmeBase, &buf_counter);
  printf(" counter %i\n",buf_counter);
  VME_READL2_1190(vmeBase, pdd , r);
  VME_ENABLE_1190(vmeBase);
  for (i=0; i<buf_counter ;i++)
    printf("%i-> %8.8x\n",i,dd[i]);
}

void rd1190h ( DWORD vmeBase , DWORD r)
{
  DWORD i, dd[1024], *pdd;
  WORD buf_counter;
  for (i=0;i<1024;i++)
    dd[i] = 0;
  pdd = &dd[0];
  VME_DISABLE_1190(vmeBase);
  VME_COUNT_1190(vmeBase, &buf_counter);
  VME_READH2_1190(vmeBase, pdd, r);
  VME_ENABLE_1190(vmeBase);
  for (i=0; i<buf_counter ;i++)
    printf("%i-> %8.8x\n",i,dd[i]);
}

void rd1190 ( DWORD vmeBase , DWORD r)
{
  DWORD i, dd[1024], *pdd;
  WORD buf_counter;
  for (i=0;i<1024;i++)
    dd[i] = 0;
  pdd = &dd[0];
  VME_DISABLE_1190(vmeBase);
  VME_COUNT_1190(vmeBase, &buf_counter);
  VME_READI4_1190(vmeBase, pdd, r);
  VME_ENABLE_1190(vmeBase);
  for (i=0; i<buf_counter ;i++)
    printf("%i-> %8.8x\n",i,dd[i]);
}

void rd1151 (DWORD vmeBase)
{
  DWORD i, dd[16], *pdd;
  for (i=0;i<16;i++)
    dd[i] = 0;
  pdd = &dd[0];
  VME_READ_1151(vmeBase, pdd, 16);
  for (i=0; i<16 ;i++)
    printf("%i-> %8.8x\n",i,dd[i]);
}

void ena1190 (DWORD vmeBase)
{
  VME_ENABLE_1190 (vmeBase);
}

void dis1190 (DWORD vmeBase)
{
  VME_DISABLE_1190 (vmeBase);
}

void res1190 (DWORD vmeBase)
{
  VME_RESET_1190 (vmeBase);
}

void clr1151(DWORD vmeBase)
{
  VME_CLEAR_1151(vmeBase);
}

void test (void)
{
  VME_RESET_1190 (PCOS_12);
}
