/*-----------------------------------------------------------------------------
 * Copyright (c) 1996      TRIUMF Data Acquistion Group
 * Please leave this header in any reproduction of that distribution
 * 
 * TRIUMF Data Acquisition Group, 4004 Wesbrook Mall, Vancouver, B.C. V6T 2A3
 * Email: online@triumf.ca           Tel: (604) 222-1047  Fax: (604) 222-1074
 *         amaudruz@triumf.ca
 * ----------------------------------------------------------------------------
 *  
 * Description	: VME test function for the LRS1151 using Macros from 
 *		  the lrs1151.h.
 *		  Display result on the VME console screen.
 *		  No reference to Midas.
 *
 * Author:  Pierre-Andre Amaudruz Data Acquisition Group
 * 
 * Revision 1.0  1996/ Pierre	 Initial revision
 * Revision 1.1  1998/ Pierre	 Split include for specific hardware.
 * ---------------------------------------------------------------------------- */
/*------------------------------------------------------------------------------------*/
typedef unsigned long  DWORD;
typedef unsigned short WORD;

#include "lrs1151.h"

void lrs1151(void)
{
  printf("---> VME Macros (lrs1151.h) <---\n");
  printf("clr1151  (0x7a00)           <--- clear   VME scaler\n");
  printf("rd1151   (0x7a00)           <--- read    VME scaler\n");
}
void rd1151 (DWORD vmeBase)
{
  DWORD i, dd[16], *pdd;
  for (i=0;i<16;i++)
    dd[i] = 0;
  pdd = &dd[0];
  VME_READ_1151(vmeBase, pdd, 16);
  for (i=0; i<16 ;i++)
    printf("%i-> %8.8x\n",i,dd[i]);
}

void clr1151(DWORD vmeBase)
{
  VME_CLEAR_1151(vmeBase);
}
