/*-----------------------------------------------------------------------------
 * Copyright (c) 1996      TRIUMF Data Acquistion Group
 * Please leave this header in any reproduction of that distribution
 * 
 * TRIUMF Data Acquisition Group, 4004 Wesbrook Mall, Vancouver, B.C. V6T 2A3
 * Email: online@triumf.ca           Tel: (604) 222-1047  Fax: (604) 222-1074
 *         amaudruz@triumf.ca
 * ----------------------------------------------------------------------------
 *  
 * Description	: VME test function for the LRS1190 using Macros from 
 *		  the lrs1190.h.
 *		  Display result on the VME console screen.
 *		  No reference to Midas.
 *
 * Author:  Pierre-Andre Amaudruz Data Acquisition Group
 * 
 * Revision 1.0  1996/ Pierre	 Initial revision
 * Revision 1.1  1998/ Pierre	 Split include for specific hrdware.
 * ---------------------------------------------------------------------------- */
/*------------------------------------------------------------------------------------*/
typedef unsigned long  DWORD;
typedef unsigned short WORD;

#include "lrs1190.h"

void lrs1190(void)
{
  printf("---> VME Macros (lrs1190.h) <---\n");
  printf("ena1190  (0x7f0000)         <--- enable  VME buffer\n");
  printf("dis1190  (0x7f0000)         <--- disable VME buffer\n");
  printf("res1190  (0x7f0000)         <--- reset   VME buffer\n");
  printf("cn1190   (0x7f0000)         <--- read    word count register\n");
  printf("rd1190   (0x7f0000)         <--- read             VME buffer\n");
  printf("rd1190l  (0x7f0000)         <--- read low  word   VME buffer\n");
  printf("rd1190h  (0x7f0000)         <--- read high word   VME buffer\n");
}

void ena1190 (DWORD vmeBase)
{
  VME_ENABLE_1190 (vmeBase);
}

void dis1190 (DWORD vmeBase)
{
  VME_DISABLE_1190 (vmeBase);
}

void res1190 (DWORD vmeBase)
{
  VME_RESET_1190 (vmeBase);
}

void cn1190 ( DWORD vmeBase)
{
  WORD count;
VME_COUNT_1190(vmeBase, &count);
printf(" counter %i\n",count);
}

void rd1190l ( DWORD vmeBase , DWORD r)
{
  DWORD i, dd[1024], *pdd;
  WORD buf_counter;
  for (i=0;i<1024;i++)
    dd[i] = 0;
  pdd = &dd[0];
  VME_DISABLE_1190(vmeBase);
  VME_COUNT_1190(vmeBase, &buf_counter);
  printf(" counter %i\n",buf_counter);
  VME_READL2_1190(vmeBase, pdd , r);
  VME_ENABLE_1190(vmeBase);
  for (i=0; i<buf_counter ;i++)
    printf("%i-> %8.8x\n",i,dd[i]);
}

void rd1190h ( DWORD vmeBase , DWORD r)
{
  DWORD i, dd[1024], *pdd;
  WORD buf_counter;
  for (i=0;i<1024;i++)
    dd[i] = 0;
  pdd = &dd[0];
  VME_DISABLE_1190(vmeBase);
  VME_COUNT_1190(vmeBase, &buf_counter);
  VME_READH2_1190(vmeBase, pdd, r);
  VME_ENABLE_1190(vmeBase);
  for (i=0; i<buf_counter ;i++)
    printf("%i-> %8.8x\n",i,dd[i]);
}

void rd1190 ( DWORD vmeBase , DWORD r)
{
  DWORD i, dd[1024], *pdd;
  WORD buf_counter;
  for (i=0;i<1024;i++)
    dd[i] = 0;
  pdd = &dd[0];
  VME_DISABLE_1190(vmeBase);
  VME_COUNT_1190(vmeBase, &buf_counter);
  VME_READI4_1190(vmeBase, pdd, r);
  VME_ENABLE_1190(vmeBase);
  for (i=0; i<buf_counter ;i++)
    printf("%i-> %8.8x\n",i,dd[i]);
}
